PROGRAM OUTSEDIT;  { Outlands Tavern Player Database Editor Utility }

  { Started creation using CHANEDIT source code 11/29/2007. }
  { OutsEdit v1.00 officially released on Dec. 28th, 2007}
  { ================================================================== }

USES CRT, GoldWin, GoldFast, GoldRead, GoldMisc, ChasWare;

     {$I OUTVARS.INC}
     { =================================================================================== }

CONST Version: STRING = 'v1.00';  {Created 11/29/07}
          { 12/26/07: Used v0.50 beta. 12/28/07: v1.00. }

      Compile_Date: STRING = 'December 28, 2007.';

      Release_Date: STRING = 'December 28th, 2007.';  {12/28/07}
      { ------------------------------------------------ }

      CfgName: STRING = 'OUTSEDIT.CFG';

      OutsPlayer_FN: STRING = 'OUTLANDS.DAT';

      RealName    = '1';   LordName   = '2';   PlayNum   = '3';
      Visits      = '4';   HitMax     = '5';   Strength  = '6';

      { Note: PLAYNUM & VISITS vars are not usable until the  }
      { IGM is using the OUTSPLAY.DAT player database format. }

      Defense     = '7';   Charm      = '8';   Forest    = '9';
      Gems        = '0';   Gold       = 'A';   Wisdom    = 'B';
      { ------------------------------------------------------- }
      Adoptions   = 'C';   SkillPts   = 'D';   Meter      = 'E';
      Dungeon     = 'F';   Cocktail   = 'G';   Dance      = 'H';
      Punch       = 'I';   FairyFood  = 'J';   Sleeping   = 'K';
      Music       = 'L';   Attacked   = 'M';   Kitchen    = 'N';

      { Q - Quit/Save Changes.   S - Search for Player. }
      { * - New Day for Player.  X - Delete Player }

      { # - Used to test New Day's handling of Negative numbers }
      { ------------------------------------------------------- }

      TwoBillion: LongInt = 2000000000;

VAR TSearch: TAVERN_PLAYER;   { for player searches }

    TOTEdit: TAVERN_PLAYER;

    Editor_Path: STRING;      { File Vars for OUTLANDS.DAT access }

    Editor_File:  FILE OF TAVERN_PLAYER;

    IGMDir: STRING;

    RecordNum   : BYTE;

    DebugVar: BOOLEAN;

      { TempNum, Used, Found: Accessed from OUTVARS.INC.   Used }
      { in record Seek process.  }
    { ================================================================================== }

PROCEDURE READ_CONFIG;      {Created/verified 11/29/07}
  VAR Config_File: TEXT;

  PROCEDURE MakeConfig;          {verified 11/29/07}
    VAR IGMLoc: STRING;
  BEGIN
    IGMLoc:= PromptStr(0,0,60,'Enter path to Outlands Tavern IGM',' Installation ','',FALSE);
    IGMLoc:= S2U(IGMLoc);

    Addtext(AddBack(IGMLoc),CfgName,TRUE);
  END;   { ------------------------------------------------------------- }

BEGIN
  IF NOT Exist(CfgName) THEN MakeConfig;      {verified 11/29/07}

  ASSIGN(Config_File,CfgName);
  RESET(Config_File);
  Readln(Config_File,IGMDir);
  CLOSE(Config_File);

  IGMDir:= S2U(IGMDir);

  { OUTSEDIT: When run from compiler, verified that value of IGMDir is known at this point. }
END;       { Read_Config ------------------------------------------------- }


PROCEDURE READ_CUSTOMERS_FILE;    { Reads the IGM's OUTLANDS.DAT file. }
BEGIN
  Editor_Path:= S2U(IGMDIR+OutsPlayer_FN);

  FileMode:= $12;

  ASSIGN(Editor_File,Editor_Path);
  RESET(Editor_File);

  SEEK(Editor_File,RecordNum);
  READ(Editor_File,TOTEdit);

  CLOSE(Editor_File);
END;     { ---------------------------------------------------- }


PROCEDURE WRITE_CUSTOMERS_FILE;      { Writes IGM's OUTLANDS.DAT file }
BEGIN
  Editor_Path:= S2U(IGMDIR+OutsPlayer_FN);

  FileMode:= $12;

  ASSIGN(Editor_File,Editor_Path);
  RESET(Editor_File);

  SEEK(Editor_File,RecordNum);
  WRITE(Editor_File,TOTEdit);

  CLOSE(Editor_File);
END;     { WRITE_CUSTOMERS_FILE   ------------------------------ }


PROCEDURE SEARCH_PLAYER(Num:INTEGER);
      { Reads OUTLANDS.DAT. Does search on player record number }
BEGIN
  Editor_Path:= S2U(IGMDIR+OutsPlayer_FN);
        {09/29/07: Changed Change_FN to Editor_Path.}

  FileMode:= $12;

  ASSIGN(Editor_File,Editor_Path);
  RESET(Editor_File);

  SEEK(Editor_File,Num);
  READ(Editor_File,TSearch);

  CLOSE(Editor_File);
END;     { SEARCH_PLAYER  --------------------------------------------- }

    
FUNCTION Get(b:CHAR): STRING;
BEGIN
  CASE UpCase(b) OF
     RealName : Get:='`!'+TOTEdit.Real_Name;

     LordName : Get:='`$'+TOTEdit.LordName;

     {  PlayNum  : Get:='`@'+N2S(TOTEdit.PlayNum);   } {Contains player's LORD player #.}

     PlayNum  : Get:= '`%N/A yet';   {12/02/07 temp code}

     Visits   : Get:= '`%N/A yet';   {12/02/07 temp code}

     {  Visits   : IF TOTEdit.Visits = 0
                  THEN  Get:= '`#None'
                  ELSE  Get:= '`$'+N2S(TOTEdit.Visits);   }

     HitMax   : IF TOTEdit.HitMax = 0
                  THEN  Get:= '`#None'
                  ELSE  Get:= '`$'+COMMA(TOTEdit.HitMax);

     Strength : IF TOTEdit.Strength = 0
                  THEN  Get:= '`#None'
                  ELSE  Get:= '`$'+COMMA(TOTEdit.Strength);

     Defense  : IF TOTEdit.Defense = 0
                  THEN  Get:= '`#None'
                  ELSE  Get:= '`$'+COMMA(TOTEdit.Defense);

     Charm    : IF TOTEdit.Charm = 0
                  THEN  Get:= '`#None'
                  ELSE  Get:= '`$'+COMMA(TOTEdit.Charm);

     Forest   : IF TOTEdit.Forest = 0
                  THEN  Get:= '`#None'
                  ELSE  Get:= '`$'+COMMA(TOTEdit.Forest);

     Gems     : IF TOTEdit.Gems = 0
                  THEN  Get:= '`#None'
                  ELSE  Get:= '`$'+COMMA(TOTEdit.Gems);

     Gold     : IF TOTEdit.Gold = 0
                  THEN  Get:= '`#None'
                  ELSE  Get:= '`$'+COMMA(TOTEdit.Gold);

     Wisdom   : IF TOTEdit.Wisdom = 0
                  THEN  Get:= '`#None'
                  ELSE  Get:= '`$'+COMMA(TOTEdit.Wisdom);

     { ================== Coded 12/02/07: =================== }
     Adoptions: IF TOTEdit.Adoptions = 0
                  THEN  Get:= '`#None'
                  ELSE  Get:= '`$'+COMMA(TOTEdit.Adoptions);

     SkillPts : IF TOTEdit.Skill_Points = 0
                  THEN  Get:= '`#None'
                  ELSE  Get:= '`$'+N2S(TOTEdit.Skill_Points);

     Meter    : IF TOTEdit.Drunk_Meter = 0
                  THEN  Get:= '`#None'
                  ELSE  Get:= '`$'+N2S(TOTEdit.Drunk_Meter);

     Dungeon  : IF TOTEdit.Captured THEN Get:= '`@Yes! '
                  ELSE Get:= '`0Nope!';  {Boolean VAR}

     Cocktail : IF TOTEdit.Cocktail THEN Get:= '`@Yes! '
                  ELSE Get:= '`0Nope!';  {Boolean VAR}

     Dance    : IF TOTEdit.Dance THEN Get:= '`@Yes! '
                  ELSE Get:= '`0Nope!';  {Boolean VAR}

     Punch    : IF TOTEdit.DrinkPunch THEN Get:= '`@Yes! '
                  ELSE Get:= '`0Nope!';  {Boolean VAR}

     FairyFood: IF TOTEdit.FairyFood THEN Get:= '`@Yes! '
                  ELSE Get:= '`0Nope!';  {Boolean VAR}

     Sleeping : IF TOTEdit.Sleeping THEN Get:= '`@Yes! '
                  ELSE Get:= '`0Nope!';  {Boolean VAR}

     Music    : IF TOTEdit.Switch_Muse THEN Get:= '`@Yes! '
                  ELSE Get:= '`0Nope!';  {Boolean VAR}

     Attacked : IF TOTEdit.UnderAttack THEN Get:= '`@Yes! '
                  ELSE Get:= '`0Nope!';  {Boolean VAR}

     Kitchen  : IF TOTEdit.UsedBack THEN Get:= '`@Yes! '
                  ELSE Get:= '`0Nope!';  {Boolean VAR}
  END;  {CASE}

  CursorOff;   {10/15/07.  needed to fix bug found by Dennis Collins}
               { in 2006 when he checked on KLBEDIT. }

    { When program's user would change a setting in a dialog box, when }
    { they returned to the main screen, the cursor would be back on the }
    { screen, so this keeps the cursor deactivated while the editor runs. }
END;     { GET Func. ----------------------------------------------------- }



{ 1 }PROCEDURE DO_REAL_NAME;          {VERIFIED 12/03/07}
BEGIN
  TOTEdit.Real_Name:=
  PromptStr(0,0,50,'Enter REAL name for player',' Player Real Name Change ',TOTEdit.Real_Name,FALSE);

  WRITE_CUSTOMERS_FILE;
  CWriteXy(22,4,Replicate(50,' '));  { Write data on position 25, Line #4. }
  CWriteXy(22,4,Get(RealName));
END;


{ 2 }PROCEDURE DO_LORD_NAME;            {VERIFIED 12/03/07}
BEGIN
  TOTEdit.LordName:=
  PromptStr(0,0,20,'Enter LORD Name for player',' Player Lord Name Change ',TOTEdit.LordName,FALSE);

  WRITE_CUSTOMERS_FILE;
  CwriteXY(22,5,Replicate(20,' '));
  CwriteXY(22,5,Get(LordName));
END;


(*  { ##### Not usable yet.  Coding done 11/29/07.  ##### }

  { In normal usage, don't allow users to change LORD Player Numbers. }

{ 3 }PROCEDURE DO_PLAYER_NUMBER;              {UNTESTED}
BEGIN
  TOTEdit.PlayNum:=
  PromptNum(0,0,'Enter player''s LORD Player # (0-160)?',' LORD Player Number Change ',TOTEdit.PlayNum,0,160,TRUE);

  WRITE_CUSTOMERS_FILE;
  CWriteXy(58,5,Replicate(5,' '));    { Allow room for 3 digits, and 2 blank spaces. 07/13/05}
  CWriteXy(58,5,Get(PlayNum));
END;             *)


{ 4 }PROCEDURE DO_VISITS;               {VERIFIED 12/03/07}
BEGIN
(*  TOTEdit.Visits:=
  PromptNum(0,0,'Enter Visits Today (0-10)?',' Visits Today Change',TOTEdit.Visits,0,10,TRUE);  *)

  WRITE_CUSTOMERS_FILE;
  CwriteXY(22,6,Replicate(5,' '));
  CwriteXY(22,6,Get(Visits));
END;   {IGM's Max Visits/Day Limit is 10.}


{ 5 }PROCEDURE DO_MAX_HITPOINTS;                 {VERIFIED 12/03/07}
BEGIN
  TOTEdit.HitMax:=
  PromptNum(0,0,'Enter # of Max HitPoints (0-16,000)?',' Max HitPoints Today Change',TOTEdit.HitMax,0,16000,TRUE);

  WRITE_CUSTOMERS_FILE;
  CWriteXY(58,6,Replicate(6,' '));
  CWriteXY(58,6,Get(HitMax));
END;


{ 6 }PROCEDURE DO_STRENGTH_POINTS;                 {VERIFIED 12/03/07}
BEGIN
  TOTEdit.Strength:=
  PromptNum(0,0,'Enter # of Strength (0-16,000)?',' Strength Change ',TOTEdit.Strength,0,16000,TRUE);

  WRITE_CUSTOMERS_FILE;
  CWriteXY(22,7,Replicate(6,' '));
  CWriteXY(22,7,Get(Strength));
END;


{ 7 }PROCEDURE DO_DEFENSE_POINTS;               {VERIFIED 12/03/07}
BEGIN
  TOTEdit.Defense:=
  PromptNum(0,0,'Enter Defense Points (0-16,000)?',' Defense Change ',TOTEdit.Defense,0,16000,TRUE);

  WRITE_CUSTOMERS_FILE;
  CwriteXY(58,7,Replicate(6,' '));
  CwriteXY(58,7,Get(Defense));
END;


{ 8 }PROCEDURE DO_CHARM_POINTS;               {VERIFIED 12/03/07}
BEGIN
  TOTEdit.Charm:=
  PromptNum(0,0,'Enter Charm Points (0-16,000)?',' Charm Change ',TOTEdit.Charm,0,16000,TRUE);

  WRITE_CUSTOMERS_FILE;
  CwriteXY(22,8,Replicate(6,' '));
  CwriteXY(22,8,Get(Charm));
END;


{ 9 }PROCEDURE DO_FOREST_FIGHTS;               {VERIFIED 12/03/07}
BEGIN
  TOTEdit.Forest:=
    PromptNum(0,0,'Enter Forest Fights (0-16,000)?',' Forest Fights Change', TOTEdit.Forest,0,16000,TRUE);

  WRITE_CUSTOMERS_FILE;
  CwriteXY(58,8,Replicate(6,' '));
  CwriteXY(58,8,Get(Forest));
END;


{ 0 }PROCEDURE DO_GEMS;      {VERIFIED 12/03/07}
BEGIN
  TOTEdit.Gems:=
   PromptNum(0,0,'Enter # of Gems (0-16,000)?',' Gems Change', TOTEdit.Gems,0,16000,TRUE);

  WRITE_CUSTOMERS_FILE;
  CwriteXY(22,9,Replicate(6,' '));
  CwriteXY(22,9,Get(Gems));
END;


{ A }PROCEDURE DO_GOLD_COINS;               {VERIFIED 12/03/07}
BEGIN
  TOTEdit.Gold:=
    PromptNum(0,0,'Enter Gold Coins (0-2 Billion)?',' Gold Found/Lost Change', TOTEdit.Gold,0,TwoBillion,TRUE);

  WRITE_CUSTOMERS_FILE;
  CwriteXY(51,9,Replicate(12,' '));
  CwriteXY(51,9,Get(Gold));
END;


{ B }PROCEDURE DO_WISDOM_POINTS;               {VERIFIED 12/03/07}
BEGIN
  TOTEdit.Wisdom:=
    PromptNum(0,0,'Enter Wisdom Points (0-2 Billion)?',' Wisdom Points Change', TOTEdit.Wisdom,0,TwoBillion,TRUE);

  WRITE_CUSTOMERS_FILE;
  CwriteXY(22,10,Replicate(12,' '));
  CwriteXY(22,10,Get(Wisdom));
END;


{ C }PROCEDURE DO_ADOPTIONS;                 {VERIFIED 12/03/07}
BEGIN
  TOTEdit.Adoptions:=
  PromptNum(0,0,'Enter # of Adoptions (0-100)?',' Adoptions Change',TOTEdit.Adoptions,0,100,TRUE);

  WRITE_CUSTOMERS_FILE;
  CWriteXY(58,10,Replicate(6,' '));
  CWriteXY(58,10,Get(Adoptions));
END;


{ D }PROCEDURE DO_SKILL_POINTS;                 {VERIFIED 12/03/07}
BEGIN
  TOTEdit.Skill_Points:=
  PromptNum(0,0,'Enter # of Skill Points (0-10)?',' Skill Points Change',TOTEdit.Skill_Points,0,10,TRUE);

  WRITE_CUSTOMERS_FILE;
  CWriteXY(22,11,Replicate(6,' '));
  CWriteXY(22,11,Get(SkillPts));
END;


{ E }PROCEDURE DO_DRUNK_METER;                 {VERIFIED 12/03/07}
BEGIN
  TOTEdit.Drunk_Meter:=
  PromptNum(0,0,'Enter Drunk Level amount (-110 to 200)?',' Drunk Meter Change',TOTEdit.Drunk_Meter,-110,200,TRUE);

  WRITE_CUSTOMERS_FILE;
  CWriteXY(58,11,Replicate(6,' '));
  CWriteXY(58,11,Get(Meter));
END;


{ F }PROCEDURE DO_Captured;                 {VERIFIED 12/03/07}
BEGIN
  IF TOTEdit.Captured = TRUE THEN TOTEdit.Captured:= FALSE
    ELSE IF TOTEdit.Captured = FALSE THEN TOTEdit.Captured:= TRUE;

  WRITE_CUSTOMERS_FILE;
  CWriteXY(24,12,Replicate(6,' '));
  CWriteXY(24,12,Get(Dungeon));
END;


{ G }PROCEDURE DO_Cocktail;                 {VERIFIED 12/03/07}
BEGIN
  IF TOTEdit.Cocktail = TRUE THEN TOTEdit.Cocktail:= FALSE
    ELSE IF TOTEdit.Cocktail = FALSE THEN TOTEdit.Cocktail:= TRUE;

  WRITE_CUSTOMERS_FILE;
  CWriteXY(58,12,Replicate(6,' '));
  CWriteXY(58,12,Get(Cocktail));
END;


{ H }PROCEDURE DO_Dance;                 {VERIFIED 12/03/07}
BEGIN
  IF TOTEdit.Dance = TRUE THEN TOTEdit.Dance:= FALSE
    ELSE IF TOTEdit.Dance = FALSE THEN TOTEdit.Dance:= TRUE;

  WRITE_CUSTOMERS_FILE;
  CWriteXY(24,13,Replicate(6,' '));
  CWriteXY(24,13,Get(Dance));
END;


{ I }PROCEDURE DO_Drink_Punch;                 {VERIFIED 12/03/07}
BEGIN
  IF TOTEdit.DrinkPunch = TRUE THEN TOTEdit.DrinkPunch:= FALSE
    ELSE IF TOTEdit.DrinkPunch = FALSE THEN TOTEdit.DrinkPunch:= TRUE;

  WRITE_CUSTOMERS_FILE;
  CWriteXY(58,13,Replicate(6,' '));
  CWriteXY(58,13,Get(Punch));
END;


{ J }PROCEDURE DO_Fairy_Food;                 {VERIFIED 12/03/07}
BEGIN
  IF TOTEdit.FairyFood = TRUE THEN TOTEdit.FairyFood:= FALSE
    ELSE IF TOTEdit.FairyFood = FALSE THEN TOTEdit.FairyFood:= TRUE;

  WRITE_CUSTOMERS_FILE;
  CWriteXY(24,14,Replicate(6,' '));
  CWriteXY(24,14,Get(FairyFood));
END;


{ K }PROCEDURE DO_Sleeping;                 {VERIFIED 12/03/07}
BEGIN
  IF TOTEdit.Sleeping = TRUE THEN TOTEdit.Sleeping:= FALSE
    ELSE IF TOTEdit.Sleeping = FALSE THEN TOTEdit.Sleeping:= TRUE;

  WRITE_CUSTOMERS_FILE;
  CWriteXY(58,14,Replicate(6,' '));
  CWriteXY(58,14,Get(Sleeping));
END;


{ L }PROCEDURE DO_SWITCH_MUSIC;                 {VERIFIED 12/03/07}
BEGIN
  IF TOTEdit.Switch_Muse = TRUE THEN TOTEdit.Switch_Muse:= FALSE
    ELSE IF TOTEdit.Switch_Muse = FALSE THEN TOTEdit.Switch_Muse:= TRUE;

  WRITE_CUSTOMERS_FILE;
  CWriteXY(24,15,Replicate(6,' '));
  CWriteXY(24,15,Get(Music));
END;


{ M }PROCEDURE DO_Under_Attack;                 {VERIFIED 12/03/07}
BEGIN
  IF TOTEdit.UnderAttack = TRUE THEN TOTEdit.UnderAttack:= FALSE
    ELSE IF TOTEdit.UnderAttack = FALSE THEN TOTEdit.UnderAttack:= TRUE;

  WRITE_CUSTOMERS_FILE;
  CWriteXY(58,15,Replicate(6,' '));
  CWriteXY(58,15,Get(Attacked));
END;


{ N }PROCEDURE DO_USED_KITCHEN;                 {VERIFIED 12/03/07}
BEGIN
  IF TOTEdit.UsedBack = TRUE THEN TOTEdit.UsedBack:= FALSE
    ELSE IF TOTEdit.UsedBack = FALSE THEN TOTEdit.UsedBack:= TRUE;

  WRITE_CUSTOMERS_FILE;
  CWriteXY(24,16,Replicate(6,' '));
  CWriteXY(24,16,Get(Kitchen));
END;


{ note: To use Y, N responses via keyboard, one has to use
  the ALT key. Or simply use the mouse to click on the option wanted. }


{ * }PROCEDURE DO_NEW_DAY;        {VERIFIED 12/03/07}
BEGIN
  CWGotoXY(5,24);
  CWriteLn('  `0Running `!"Reset Player''s Stats" `0process. 3-second delay.');

  DELAY(3000);

  (* {not usable yet}

  IF (TOTEdit.PlayNum > 160) THEN
    BEGIN
      TOTEdit.PlayNum:= 160;
      PromptOK('Advisory:',' Resetting LORD Player # field to 160.');
    END;            *)

  { --------------------------------------------------- }
  (*  {Not usable yet}

  IF TOTEdit.Visits > 0 THEN
    BEGIN
      TOTEdit.Visits:= 0;
      PromptOK('Advisory:',' Resetting the Visits Today field to Zero.');
    END;         *)

  { --------------------------------------------------- }
  IF TOTEdit.HitMax < 0 THEN
    BEGIN
      TOTEdit.HitMax:= 0;
      PromptOK('Advisory:',' Reset negative Max HitPoints field to Zero.');
    END;

  IF TOTEdit.HitMax > 0 THEN      {VERIFIED 12/03/07}
    BEGIN
      TOTEdit.HitMax:= 0;
      PromptOK('Advisory:',' Resetting the Max HitPoints field to Zero.');
    END;

  { --------------------------------------------------- }
  IF TOTEdit.Strength < 0 THEN
    BEGIN
      TOTEdit.Strength:= 0;
      PromptOK('Advisory:',' Reset negative Strength Points field to Zero.');
    END;

  IF TOTEdit.Strength > 0 THEN    {VERIFIED 12/03/07}
    BEGIN
      TOTEdit.Strength:= 0;
      PromptOK('Advisory:',' Resetting the Strength Points field to Zero.');
    END;

  { --------------------------------------------------- }
  IF TOTEdit.Defense < 0 THEN
    BEGIN
      TOTEdit.Defense:= 0;
      PromptOK('Advisory:',' Reset negative Defense Points field to Zero.');
    END;

  IF TOTEdit.Defense > 0 THEN     {VERIFIED 12/03/07}
    BEGIN
      TOTEdit.Defense:= 0;
      PromptOK('Advisory:',' Resetting the Defense Points field to Zero.');
    END;

  { --------------------------------------------------- }
  IF TOTEdit.Charm < 0 THEN
    BEGIN
      TOTEdit.Charm:= 0;
      PromptOK('Advisory:',' Reset negative Charm Points field to Zero.');
    END;

  IF TOTEdit.Charm > 0 THEN       {VERIFIED 12/03/07}
    BEGIN
      TOTEdit.Charm:= 0;
      PromptOK('Advisory:',' Resetting the Charm Points field to Zero.');
    END;

  { --------------------------------------------------- }
  IF TOTEdit.Forest < 0 THEN
    BEGIN
      TOTEdit.Forest:= 0;
      PromptOK('Advisory:',' Reset negative Forest Fights field to Zero.');
    END;

  IF TOTEdit.Forest > 0 THEN      {VERIFIED 12/03/07}
    BEGIN
      TOTEdit.Forest:= 0;
      PromptOK('Advisory:',' Resetting the Forest Fights field to Zero.');
    END;

  { --------------------------------------------------- }
  IF TOTEdit.Gems < 0 THEN
    BEGIN
      TOTEdit.Gems:= 0;
      PromptOK('Advisory:',' Reset negative Gems field to Zero.');
    END;

  IF TOTEdit.Gems > 0 THEN        {VERIFIED 12/03/07}
    BEGIN
      TOTEdit.Gems:= 0;
      PromptOK('Advisory:',' Resetting the Gems field to Zero.');
    END;

  { --------------------------------------------------- }
  IF TOTEdit.Gold < 0 THEN
    BEGIN
      TOTEdit.Gold:= 0;
      PromptOK('Advisory:',' Reset negative Gold Coins field to Zero.');
    END;

  IF TOTEdit.Gold > 0 THEN        {VERIFIED 12/03/07}
    BEGIN
      TOTEdit.Gold:= 0;
      PromptOK('Advisory:',' Resetting the Gold Coins field to Zero.');
    END;

  { --------------------------------------------------- }
  IF TOTEdit.Wisdom < 0 THEN
    BEGIN
      TOTEdit.Wisdom:= 0;
      PromptOK('Advisory:',' Reset negative Wisdom Points field to Zero.');
    END;

  IF TOTEdit.Wisdom > 0 THEN      {VERIFIED 12/03/07}
    BEGIN
      TOTEdit.Wisdom:= 0;
      PromptOK('Advisory:',' Resetting the Wisdom Points field to Zero.');
    END;

  { --------------------------------------------------- }
  IF TOTEdit.Adoptions < 0 THEN   {Coded 12/02/07: VERIFIED 12/28/07}
    BEGIN
      TOTEdit.Adoptions:= 0;
      PromptOK('Advisory:',' Reset negative Adoptions field to Zero.');
    END;

  IF TOTEdit.Adoptions > 0 THEN   {Coded 12/02/07: VERIFIED 12/03/07}
    BEGIN
      TOTEdit.Adoptions:= 0;
      PromptOK('Advisory:',' Resetting the Adoptions field to Zero.');
    END;

  { --------------------------------------------------- }
  { Skill_Points is BYTE. Value can't be negative }

  IF TOTEdit.Skill_Points > 0 THEN  {Coded 12/02/07: VERIFIED 12/03/07}
    BEGIN
      TOTEdit.Skill_Points:= 0;
      PromptOK('Advisory:',' Resetting the Skill Points field to Zero.');
    END;

{ Coding for use with Outlands Tavern v1.64 beta done to here }
{ 04:40 pm 12/02/2007 }

  { --------------------------------------------------- }
  { Drunk Meter has valid values that are negative. }
  { Will have to analyze igm for this section's coding: }
  { Drunk_Meter is SHORTINT var type currently. Can be negative amount }

  IF TOTEdit.Drunk_Meter > 0 THEN   {Coded 12/02/07: VERIFIED 12/03/07}
    BEGIN
      TOTEdit.Drunk_Meter:= 0;
      PromptOK('Advisory:',' Resetting the Drunk Meter field to Zero.');
    END;

  { Boolean variables: All get reset to FALSE: }

  TOTEdit.Cocktail:= FALSE;     {12/02/07}

  TOTEdit.Dance:=    FALSE;     {12/02/07}

  TOTEdit.DrinkPunch:= FALSE;   {12/02/07}

  TOTEdit.FairyFood:= FALSE;    {12/02/07}

  TOTEdit.Switch_Muse:= FALSE;  {12/02/07}

  TOTEdit.UsedBack:= FALSE;     {12/02/07}

  IF (TOTEdit.UnderAttack) AND (TOTEdit.Captured) THEN   {Added/Verified 12/28/07}
    BEGIN
      TOTEdit.UnderAttack:= FALSE;
      PromptOK('Advisory:',' Reset invalid value of Under Attack variable.');
    END;   {UnderAttack VAR is not used with players in the Dungeon}

  IF (TOTEdit.Sleeping) AND (TOTEdit.Captured) THEN   {Added/Verified 12/28/07}
    BEGIN
      TOTEdit.Captured:= FALSE;
      PromptOK('Advisory:',' Reset invalid value of In the Dungeon variable.');
    END;    {Sleeping VAR is not used with players in the Dungeon}

  { Should NOT be changed by New Day process: Captured, Sleeping, }
  { and UnderAttack. }

END;     { DO_NEW_DAY  ================================== }


FUNCTION  MaxPlayers: WORD; { Gets the number of customer records }
BEGIN
  MaxPlayers:= 1;

  Editor_Path:= S2U(IGMDIR+OutsPlayer_FN);

  IF NOT Exist(Editor_Path) THEN Exit;

  FileMode:= $12;

  ASSIGN(Editor_File,Editor_Path);
  RESET(Editor_File);

  MaxPlayers:= FileSize(Editor_File);

  CLOSE(Editor_File);
END;     { MaxPlayers  --------------------------------------------- }


FUNCTION GetRecordNum: STRING;
BEGIN
  GetRecordNum:='`$'+N2S(RecordNum + 1)+' `%of `@'+N2S(MaxPlayers);
    { First record # displayed will be 1, not 0. }
END;     { GetRecordNum ---------------------------------------------- }


PROCEDURE ShowMenu;          {VERIFIED 12/03/07}
BEGIN
  ClrScr;

  CWritelnC('`%** `$Outlands Tavern `0Player Database Editor `!'+Version+' `%**');  {Line 1}
  CWritelnC('`@OUTLANDS.DAT `%Record Number: '+GetRecordNum);              {Line 2}
  CWriteLn(' ');

  { CwGotoXY, CWriteXY notes: X is position #, Y is line #. }

  CWGotoXY(3,4);   { Line 4 }
  CWriteLN('`#(`%1`#) `!Real Name    `%: '+Get(RealName));

  { -------------------------------------------- }
  CWGotoXY(3,5);                {Line 5}
    CWrite('`#(`%2`#) `!LORD Name    `%: '+Get(LordName));

  CWGotoXY(45,5);
  CWriteLN('`#(`%3`#) `!Player #`%: '+Get(PlayNum));
  { -------------------------------------------- }

   { Not usable until IGM is actually using VISITS field}

  CWGotoXY(3,6);        {Line 6, column 1. temp coding}
  CWrite('`#(`%4`#) `!Visits Today `%:  '+Get(Visits));

  CWGotoXY(38,6);
  CWriteLN('`#(`%5`#) `!Max HitPoints `%: '+Get(HitMax));
  { -------------------------------------------- }

  CWGotoXY(3,7);                {Line 7}
    CWrite('`#(`%6`#) `!Strength Pts `%: '+Get(Strength));

  CWGotoXY(38,7);
  CWriteLN('`#(`%7`#) `!Defense Points`%: '+Get(Defense));
  { -------------------------------------------- }

  CWGotoXY(3,8);                 {Line 8}
   CWrite('`#(`%8`#) `!Charm Points `%: '+Get(Charm));

  CWGotoXY(38,8);
  CWriteLN('`#(`%9`#) `!Forest Fights `%: '+Get(Forest));
  { -------------------------------------------- }

  { Note: All lines from here to the end of SHOWMENU }
  { process were written in 12/02/2007 coding sessions. }

  CWGotoXY(3,9);                 {Line 9. Coded 12/02/2007}
    CWrite('`#(`%0`#) `!Gems Found   `%: '+Get(Gems));

  CWGotoXY(34,9);
  CWriteLN('`#(`%A`#) `!Gold Coins `%: '+Get(Gold));
  { -------------------------------------------- }

  CWGotoXY(3,10);                 {Line 10. Coded 12/02/2007}
   CWrite('`#(`%B`#) `!Wisdom Points`%: '+Get(Wisdom));

  CWGotoXY(38,10);
  CWriteLN('`#(`%C`#) `!Kids Adopted  `%: '+Get(Adoptions));
  { -------------------------------------------- }

  CWGotoXY(3,11);                 {Line 11. Coded 12/02/2007}
   CWrite('`#(`%D`#) `!Skill Points `%: '+Get(SkillPts));

  CWGotoXY(38,11);
  CWriteLN('`#(`%E`#) `!Drunk Meter # `%: '+Get(Meter));
  { -------------------------------------------- }

  CWGotoXY(3,12);                 {Line 12. Coded 12/02/2007}
    CWrite('`#(`%F`#) `!In the Dungeon?`%: '+Get(Dungeon));

  CWGotoXY(38,12);
  CWriteLN('`#(`%G`#) `!Had Cocktail? `%: '+Get(Cocktail));
  { -------------------------------------------- }

  CWGotoXY(3,13);                 {Line 13. Coded 12/02/2007}
    CWrite('`#(`%H`#) `!Had Dance yet? `%: '+Get(Dance));

  CWGotoXY(38,13);
  CWriteLN('`#(`%I`#) `!Drunk Punch?  `%: '+Get(Punch));
  { -------------------------------------------- }

  CWGotoXY(3,14);                 {Line 14. Coded 12/02/2007}
   CWrite('`#(`%J`#) `!Had Fairy Food?`%: '+Get(FairyFood));

  CWGotoXY(38,14);
  CWriteLN('`#(`%K`#) `!Asleep in IGM?`%: '+Get(Sleeping));
  { -------------------------------------------- }

  CWGotoXY(3,15);                 {Line 14. Coded 12/02/2007}
   CWrite('`#(`%L`#) `!Switched Music?`%: '+Get(Music));

  CWGotoXY(38,15);
  CWriteLN('`#(`%M`#) `!Under Attack? `%: '+Get(Attacked));
  { -------------------------------------------- }

  CWGotoXY(3,16);                 {Line 14. Coded 12/02/2007}
  CWriteLN('`#(`%N`#) `!Used Kitchen?  `%: '+Get(Kitchen));
  { -------------------------------------------- }

  CWriteLn(' ');  {Blank Line, Line #17}

  { --------------------------------------------------------------- }
  CWGotoXY(3,18);
	 CWrite('`2(`0S`2) `%Search by Name');

  CWGotoXY(40,18);   {12/02/07 coding}
  CWriteLn('`2(`0X`2) `%Delete Player record');
  { -------------------------------------------- }

  CWGotoXY(3,19);    {12/02/07 coding}
  CWrite('`2(`0]`2) `%Advance One Record');

  CWGotoXY(40,19);   {12/02/07 coding}
  CWriteLn('`2(`0[`2) `%Back Up One Record');
  { -------------------------------------------- }

  CWGotoXY(3,20);    {12/02/07 coding}
  CWrite('`2(`0*`2) `%Reset Player Stats');

  CWGotoXY(40,20);   {Added 12/28/07}
  CWriteLn('`2(`0#`2) `%New Day Process Testing');
  { -------------------------------------------- }

  BLANK(1);   {Blank line.  #21. 12/02/07 coding}

  CWGotoXY(3,22);    {LIne #22.  12/02/07 coding}
  Cwrite('`$    Input key to change, or `%Q `$to quit and save.');
END;     { ShowMenu  ----------------------------------------- }


       { 12/02/07: Changed X menu code to S for DO_PLAYER_SEARCH. }
{ S }PROCEDURE DO_PLAYER_SEARCH;       {VERIFIED}
VAR Counter, YN : BYTE;
    Temp, OTemp : STRING;

BEGIN
  Editor_Path:= S2U(IGMDIR+OutsPlayer_FN);

  IF NOT Exist(Editor_Path) THEN Exit;
     { if no OUTLANDS.DAT then we can't search and
       couldn't have made it here to begin with. }

  Counter:= 0;
  Temp:= PromptStr(0,0,50,' Enter full or partial name: ',' Player Search ','',FALSE);
  OTemp:= Temp;
  Temp:= S2U(Temp);  { upcase the whole string }

  REPEAT
    SEARCH_PLAYER(Counter);

    { This next evaluation is checking to see if TEMP exists anywhere in  }
    {  either field of record.  If YES, then execute the next section,    }
    {  otherwise increment counter and move on.  Note: Using FUNCTION NoColor  }
    {  to strip Lord color codes for string eval and display. }

	 IF (POS(Temp,S2U(TSearch.LordName))>0) OR (POS(Temp,NoColor(S2U(TSearch.Real_Name)))>0) THEN
     BEGIN
       YN:= PromptYesNo('','Are you looking for:|'+TSearch.LordName+' known as '+NoColor(TSearch.Real_Name)+'?');

       IF YN=1 THEN {1 means YES answer}
         BEGIN
            RecordNum:= Counter; { LORD Player # to display matches the counter }

            READ_CUSTOMERS_FILE;
            ShowMenu;
            Exit; { bail out of loop since we got who we want }
          END;
     END;

    Inc(Counter);
  UNTIL Counter=MaxPlayers; { End of repeat loop, repeats until we get
										to last player record. }

  { if we make it to here, then there were no matches. }

  PromptOK(' Search Error! ','No match found for '+OTemp+'!');  {02/11/04}
END;   { DO_PLAYER_SEARCH ====================================== }


{ Added 12/02/07 using modified ROL2EDIT.PAS code: }

{ X }PROCEDURE DO_PLAYER_DELETION;   {Created 12/02/07: UNTESTED}
  VAR YN: BYTE;
BEGIN
  { I hate having to bust up lines due to "line too long" error }
  { messages! The next 3 lines are all one line of code. Chas.}

  YN:= PromptYesNo
   (' Warning Will Robinson! Player Deletion! ','Are you sure you want to delete the player :|'+TOTEdit.LordName+' known'
     +' as '+NoColor(TOTEdit.Real_Name)+'?');

  IF YN = 1 THEN {1 means YES answer}
    BEGIN
      TOTEdit.Real_Name:= 'X';
      TOTEdit.LordName:= '* DELETED *';

      {  TOTEdit.PlayNum:= 160;  }  {not used by igm yet}

        { Note: PlayNum 160 should not be in use by any valid players.}

      {  TOTEdit.Visits:= 0;     }     {not used by igm yet}

      TOTEdit.Adoptions:= 0;      {Added 12/02/07}
      TOTEdit.Skill_Points:= 0;       {Added 12/02/07}
      TOTEdit.Drunk_Meter:= 0;       {Added 12/02/07}
      TOTEdit.HitMax:= 0;    {Added 12/02/07}

      TOTEdit.Strength:= 0;       {Added 12/02/07}
      TOTEdit.Defense:= 0;    {Added 12/02/07}
      TOTEdit.Charm:= 0;       {Added 12/02/07}
      TOTEdit.Gems:= 0;         {Added 12/02/07}

      TOTEdit.Gold:= 0;    {Added 12/02/07}
      TOTEdit.Wisdom:= 0;       {Added 12/02/07}

      TOTEdit.Captured:= FALSE;      {Added 12/02/07}
      TOTEdit.Cocktail:= FALSE;      {Added 12/02/07}
      TOTEdit.Dance:= FALSE;      {Added 12/02/07}
      TOTEdit.DrinkPunch:= FALSE;      {Added 12/02/07}

      TOTEdit.FairyFood:= FALSE;      {Added 12/02/07}
      TOTEdit.Sleeping:= FALSE;      {Added 12/02/07}
      TOTEdit.Switch_Muse:= FALSE;      {Added 12/02/07}
      TOTEdit.UnderAttack:= FALSE;      {Added 12/02/07}
      TOTEdit.UsedBack:= FALSE;      {Added 12/02/07}
      { ============================================================================== }

      WRITE_CUSTOMERS_FILE;

      PromptOK(' Record Deletion: ','Actual record deletion will be handled by the IGM the |'
                 +'next day, when it runs the New Day maintenance process. ');

      ShowMenu;
    END;
END;       {  DO_PLAYER_DELETION ==============================  }


(*  {Disabled after usage 01:44 pm 12/28/07}

        {Created 12/28/07 to test New Day process code}
{ # }PROCEDURE DO_NEWDAY_TESTING;   {Created 12/28/07: VERIFIED 12/28/07}
BEGIN
  TOTEdit.Adoptions:= -100;

  { Skill_Points can not be set to negative value. }

  TOTEdit.Drunk_Meter:= -100;
  TOTEdit.HitMax:= -1000;

  TOTEdit.Strength:= -1000;
  TOTEdit.Defense:= -1000;
  TOTEdit.Charm:= -1000;
  TOTEdit.Gems:= -1000;
  TOTEdit.Forest:= -1000;

  TOTEdit.Gold:= -1000000;         {Reset to -1,000,000}
  TOTEdit.Wisdom:= -1000000;       {Reset to -1,000,000}

  TOTEdit.Captured:= TRUE;
  TOTEdit.Cocktail:= TRUE;
  TOTEdit.Dance:= TRUE;
  TOTEdit.DrinkPunch:= TRUE;

  TOTEdit.FairyFood:= TRUE;
  TOTEdit.Sleeping:= TRUE;
  TOTEdit.Switch_Muse:= TRUE;
  TOTEdit.UnderAttack:= TRUE;
  TOTEdit.UsedBack:= TRUE;
  { ============================================================================== }

  WRITE_CUSTOMERS_FILE;

  PromptOK(' NewDay Testing: ','Variables reset to negative values for use in testing |'
               +'how the New Day for Player process handles them. ');

  ShowMenu;

END;  { DO_NEWDAY_TESTING ===================================== }   *)


PROCEDURE RUN_EDITOR;       {VERIFIED 12/03/07}
  VAR Code: CHAR;
BEGIN
  ShowMenu;

  REPEAT
    Code:= AInput('1234567890ABCDEFGHIJKLMNQSX][*#');
            {Added # 12/28/07 for use with DO_NEWDAY_TESTING.}

    CASE Code OF
      '1' : DO_REAL_NAME;

      '2' : DO_LORD_NAME;

      (*  {not usable yet}
      '3' : BEGIN
              CWGotoXY(1,16);   {Show text on Line 16}

              CWriteLn('  `0The `$LORD Player Number `0field is display-only.  I don''t see ');
              CWriteLn('  `0a valid reason to allow it to be edited.  3-second delay. ');
              DELAY(3000);

              IF DebugVar THEN   {coded 07/22/07: untested}
                BEGIN
                  BLANK(1);
                  CWriteLn('  `0Usage of `!/DEBUG `0parameter was detected, so user is ');
                  CWriteLn('  `0allowed to modify the Player Number field.  Do so with ');
                  CWriteLn('  `@CAUTION `0because it is a `@VERY `0important database field.');
                  DELAY(3000);

                  DO_PLAYER_NUMBER;
                END;

              ShowMenu;
            END;               *)

      (*  {not usable yet}
      '4' : DO_VISITS;         *)

      '5' : DO_MAX_HITPOINTS;

      '6' : DO_STRENGTH_POINTS;

      '7' : DO_DEFENSE_POINTS;

      '8' : DO_CHARM_POINTS;

      '9' : DO_FOREST_FIGHTS;

      '0' : DO_GEMS;

      'A' : DO_GOLD_COINS;

      'B' : DO_WISDOM_POINTS;

      'C' : DO_ADOPTIONS;          {Coded 12/02/07}

      'D' : DO_SKILL_POINTS;       {Coded 12/02/07}

      'E' : DO_DRUNK_METER;        {Coded 12/02/07}

      'F' : DO_CAPTURED;       {Coded 12/02/07}

      'G' : DO_COCKTAIL;       {Coded 12/02/07}

      'H' : DO_DANCE;                {Coded 12/02/07}

      'I' : DO_DRINK_PUNCH;          {Coded 12/02/07}

      'J' : DO_FAIRY_FOOD;           {Coded 12/02/07}

      'K' : DO_SLEEPING;             {Coded 12/02/07}

      'L' : DO_SWITCH_MUSIC;         {Coded 12/02/07}

      'M' : DO_UNDER_ATTACK;        {Coded 12/02/07}

      'N' : DO_USED_KITCHEN;        {Coded 12/02/07}

      { ------------------------------------------------------ }
      { Q - reserved for QUIT/SAVE Changes command processing. }
      { ------------------------------------------------------ }

      'S' : DO_PLAYER_SEARCH;   {revised 12/02/07}

      'X' : DO_PLAYER_DELETION;   {Coded 12/02/07}

      (*  {Disabled after usage 01:44 pm 12/28/07}
          '#' : DO_NEWDAY_TESTING;   {Coded 12/28/07: VERIFIED 12/28/07}  *)

      ']' : BEGIN                      {VERIFIED}
              Inc(RecordNum);
              IF RecordNum > (MaxPlayers - 1) THEN RecordNum:= 0;  {05/07/04 edit}

              READ_CUSTOMERS_FILE;
              ShowMenu;
            END;

      '[' : BEGIN                      {VERIFIED}
              IF RecordNum=0
                THEN RecordNum:= (MaxPlayers - 1)
                ELSE Dec(RecordNum);

              READ_CUSTOMERS_FILE;
              ShowMenu;
            END;

      '*' : BEGIN                      {VERIFIED}
              DO_NEW_DAY;

              ShowMenu;

              WRITE_CUSTOMERS_FILE;
            END;

    END;       {CASE Code - ending}
  UNTIL Code = 'Q';
END;       { RUN_EDITOR ---------------------------------------------------------- }


PROCEDURE EXIT_SCREEN;          {VERIFIED 12/03/07}
BEGIN
  { the | character will cause a linefeed, I forget what max chars }
  { are.  Anyhow, say whatever you want here or remove it totally }

  PromptOK(' Outlands Tavern''s Player Database Editor Credits: ',
      'OUTSEDIT.EXE '+Version+'.  Copyright 2007-2008 by Donald Tidmore. ||'

      +'** Dedication:  To Dennis Collins and Jason Brown. ** ||'

      {  +'** Compile Date:  '+Compile_Date+'  December 2007 Beta. ||'  }
              { Disabled 12/28/07 }

      +'v1.00 Released officially on:  '+Release_Date+' ||'  {Added 12/28/07}

      +'Database Path: '+Editor_Path);       {Compile_Date ends with period.}
END; { EXIT_SCREEN ============================================ }


BEGIN    { Main OUTSEDIT.pas BEGIN/END structure }
  ClrScr;

  CursorOff;                  {Gold Tool-Kit process}
  UseLordColors:= TRUE;

  DebugVar:= FALSE;   {07/22/07 Code}

  IF S2U(ParamStr(1)) = '/DEBUG'  {07/22/07 Code}
    THEN DebugVar:= True;

  ReadVars.ReadHelp:= NIL;  { removes the HELP button in the prompts. }   {Gold Tool-Kit process}

  WinNoClose:= TRUE;
      { removes the prompt window close button in upper left. }
		{Gold toolkit process}

  RecordNum:= 0;

  IF Exist('SKELPLAY.DAX') THEN DeleteFile('SKELPLAY.DAX');

  READ_CONFIG;  {process existing OUTSEDIT.cfg file.}

  Editor_Path:= S2U(IGMDIR+OutsPlayer_FN);

  IF Exist(Editor_Path) THEN READ_CUSTOMERS_FILE
  ELSE
    BEGIN
      CWriteLn(' ');
      CWriteLn('  `@ERROR:  `0OUTSEDIT `!could not locate the `@Outlands Tavern''s ');
      CWriteLn('  `#OUTLANDS.DAT `!file, which is `%REQUIRED `!for you to edit ');
      CWriteLn('  `!the IGM''s database records.');

      CWriteLn(' ');
      CWriteLn('  `0OUTSEDIT `!looked for this file, which was not found: ');
      CWriteLn('    `$'+Editor_Path);

      CWriteLn(' ');
      CWriteLn('  `!Terminating `0OUTSEDIT `!after 3 seconds delay.  ');

      DELAY(3000);
      HALT;
    END;
  { =========================================================== }

  RUN_EDITOR;

  EXIT_SCREEN;

  ResetStartUpMode;     {Gold Toolkit process}
END. { OUTSEDIT.pas }

{ First stage code editing finished 01:51 am 11/29/2007. }
{ Player database covered down to Wisdom variable so far. }
{ Finished coding of entire program Sunday night, 12/02/2007. Used 0.10 beta. }
{ First compilation done Dec. 02, 2007. Used 0.125, 0.15, 0.175 betas. }
{ First successful program tests completed 12/03/07. Changed to v0.20 beta}

  { 12/02/07: Coded constants D through N, S and X. }
  { Released program for beta testers usage on 12/03/2007. }

